/***************************************************************************
                          maindialog.h  -  description                              
                             -------------------                                         
    begin                : Mon Nov 15 1999                                           
    copyright            : (C) 1999 by Peter Gasparik                         
    email                : pgasparik@yahoo.com                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef MAINDIALOG_H
#define MAINDIALOG_H

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <qgroupbox.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qmultilinedit.h>
#include <qlabel.h>
#include <qprogressbar.h>
//Generated area. DO NOT EDIT!!!(end)

#include <qdialog.h>
#include <kmenubar.h>
#include <kpopmenu.h>

#include "serialport.h"

/**
  *@author Peter Gasparik
  */

class MainDialog : public QDialog
{
   Q_OBJECT
public: 
	MainDialog(QWidget *parent=0, const char *name=0);
	~MainDialog();

protected: 
	void initDialog();
	//Generated area. DO NOT EDIT!!!(begin)
	QGroupBox *FilesGroupBox;
	QListBox *FilesListBox;
	QPushButton *AddButton;
	QPushButton *RemoveButton;
	QPushButton *LoadButton;
	QMultiLineEdit *MemoEdit;
	QLabel *QLabel_1;
	QLabel *PortLabel;
	QPushButton *HelpButton;
	QProgressBar *ProgDlg;
	//Generated area. DO NOT EDIT!!!(end)
	
	QMenuBar *MainMenu;
	QPopupMenu *FileMenu, *HelpMenu;
	int EEMenuId;
	
private:
	QString fname;
	bool wasCancelled;
	bool loading;

	void enableControls(bool enable);
	void addListItem(QString &fileName);
	void writeToConfig();
	void enableButtons();
	int getBaud(const char *Key);
	bool loadBootLoader(SerialPort &comm);
	int loadApp(const char *fileName, SerialPort &comm);
	byte getByte(char *data);
	word getWord(char *data);
	void delay(int timeMs);


private slots:
	void slotAdd();
	void slotRemove();
	void slotLoad();
	void slotHelp();
};

#endif


