/***************************************************************************
                          progressdialog.cpp  -  description                              
                             -------------------                                         
    begin                : Mon Nov 15 1999                                           
    copyright            : (C) 1999 by Peter Gasparik                         
    email                : pgasparik@yahoo.com                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include <qmessagebox.h>

#include "progressdialog.h"

ProgressDialog::ProgressDialog(QWidget *parent, const char *name) :
	KDialog(parent, name, false, WType_TopLevel | WStyle_DialogBorder)
{
	initDialog();
	setCaption("Loading Progress");
	cancelled = false;
	
	connect(CancelButton, SIGNAL(clicked()), this, SLOT(slotCancel()));
}

ProgressDialog::~ProgressDialog()
{
}

void ProgressDialog::setSteps(int Current, int All)
{
	if (Current > 0)
		CurrentProgress->setTotalSteps(Current);
	if (All > 0)
		AllProgress->setTotalSteps(All);
}

void ProgressDialog::reset(bool Current, bool All)
{
	if (Current)
		CurrentProgress->reset();
	if (All)
		AllProgress->reset();
}

void ProgressDialog::setProgress(int Current, int All)
{
	if (Current > 0)
		CurrentProgress->setProgress(Current);
	if (All > 0)
		AllProgress->setProgress(All);
}

void ProgressDialog::slotCancel()
{
	if (QMessageBox::warning(this, "Confirmation", "Do you wish to cancel application loading?", QMessageBox::Yes, QMessageBox::No) == QMessageBox::Yes)
	{
		cancelled = true;
		close();
	}
}